;; WindowړIDႮ^^;
;;
;; Naoki Iwasaki

(define (is-visible hwnd)
    (let ((style (get-window-style hwnd)))
    (and (is-window         hwnd)
	 (is-window-visible hwnd)
	 (<> (logand style ws-caption) 0)
	 (<> (find-window "Shell_TrayWnd" ()) hwnd) ;; ^XNo[͂Ȃ
;	 (=  (logand style ws-popup)   0)
	 )))
      
(define (is-not-iconic hwnd)
  (not (is-iconic hwnd)))


(define (get-next lst d)
  (let ((temp (filter (curry < d) lst)))
    (if (null? temp) ()
	(head temp))))

(define (get-prev lst d)
  (let ((temp (filter (curry > d) lst)))
    (if (null? temp) ()
	(last temp))))

;; ĂEBhÊ
;; ƂZI[_[̌̃EBhE𓾂
(define (get-visible-first-window)
  (let ((fstwnd (get-window (get-foreground-window) gw-hwndfirst)))
    (if (is-visible fstwnd)
	fstwnd
	(get-visible-next-window fstwnd))))

(define (get-visible-last-window)
  (let ((lstwnd (get-window (get-foreground-window) gw-hwndlast)))
    (if (is-visible lstwnd)
	lstwnd
	(get-visible-prev-window lstwnd))))
  
(define (get-visible-next-window hwnd)
  (let ((vn (get-window hwnd gw-hwndnext)))
    (cond ((= vn 0) 0)
	  ((is-visible vn) vn)
	  (else (get-visible-next-window vn)))))

(define (get-visible-prev-window hwnd)
  (let ((vn (get-window hwnd gw-hwndprev)))
    (cond ((= vn 0) 0)
	  ((is-visible vn) vn)
	  (else (get-visible-prev-window vn)))))

;; ACRԂ̃EBhEOʂɕ\
(define (restore-window hwnd)
  (if (is-iconic hwnd)
      (show-window hwnd sw-restore))
  (set-foreground-window hwnd))

;; (next=#t => alt-tab) (next=#f => alt-shift-tab) Iȓ
(define (switch-window next)
  (if next
      (begin (set-window-pos (get-foreground-window) hwnd-bottom 0 0 0 0 (+ swp-nosize swp-nomove))
	     (restore-window (get-visible-first-window))) ; z-orderOɂCIȂ
      (restore-window (get-visible-last-window))))

(define (sef-car p)
  (if (null? p) ()
      (car p)))
(define (sef-head lst)
  (if (null? lst)
      ()
      (head lst)))
(define (sef-last lst)
  (if (null? lst)
      ()
      (last lst)))

(define (cmp-rect a b)
  (let loop ((elem '(left top right bottom)))
    (if (null? elem)
	#f
	(let ((c (rect-get (car elem) a))
	      (d (rect-get (car elem) b)))
	  (if (<> c d)
	      (>  c d)
	      (loop (cdr elem)))))))
  
;; ׂ̃EBhE݂
(define (get-neighbor-window kind way)
  (let* ((get (if way get-next get-prev))
	 (enum (filter (lambda (h) (not (is-iconic h))) (enum-visible-windows)))
	 (hwnd (get-foreground-window))
	 (point (rect-get kind (get-window-rect hwnd)))
	 (rects (sort-by (lambda (a b) (cmp-rect (cdr a) (cdr b)))
			 (map (lambda (w) (cons w (get-window-rect w))) enum)))
	 (points (map (lambda (w) (cons (car w) (rect-get kind (cdr w))))
		      rects))
	 (sorted (sort-by (lambda (a b) (< (cdr a) (cdr b))) points))
	 (next   (if way
		     (sef-head (filter (lambda (a) (< point (cdr a))) sorted))
		     (sef-last (filter (lambda (a) (> point (cdr a))) sorted)))))
    (sef-car next)))


;; wCEBhE؂ւ
(define (move-focus to)
  (let* ((arg (case to
		('left  '(left . #f))
		('right '(left . #t))
		('up    '(top  . #f))
		('down  '(top  . #t))
		(else (error "move-focus : 'up 'down 'left 'right\n"))))
	 (next (get-neighbor-window (car arg) (cdr arg))))
    (if (not (null? next))
	(set-foreground-window next))))

(define (is-normal hwnd)
  (and (not (is-iconic hwnd))
       (not (is-zoomed hwnd))))

(define (get-left-guides width hwnd)
  (let* ((visible-wins (filter (lambda (x) (not (= x hwnd)))
			       (filter is-normal (enum-visible-windows))))
	 (rects (cons (get-workarea) (map get-window-rect visible-wins)))
	 (lefts  (map rect-left  rects))
	 (rights (map rect-right rects))
	 (lefts2  (map (lambda (x) (- x width)) lefts))
	 (rights2 (map (lambda (x) (- x width)) rights)))
    (sort (uniq (append lefts rights lefts2 rights2)))))

(define (get-top-guides height hwnd)
  (let* ((visible-wins (filter (lambda (x) (not (= x hwnd)))
			       (filter is-normal (enum-visible-windows))))
	 (rects (map get-window-rect visible-wins))
	 (wtop (rect-top (get-workarea)))
	 (wbottom (- (rect-bottom (get-workarea)) height))
	 (tops    (cons wtop (map rect-top  rects)))
	 (bottoms (cons wbottom (map rect-bottom rects)))
	 (tops2   (map (lambda (x) (- x height)) tops)))
    (sort (uniq (append tops bottoms tops2)))))

;; foreground̃EBhEړ
;; ႮȂ̂ŁCdlԂς
(define (winmove kind way resize)
  (let* ((get (if way get-next get-prev))
	 (hwnd (get-foreground-window))
	 (rect (get-window-rect hwnd))
	 (wh   (case kind
		 ('left  (rect-width rect))
		 ('top (rect-height rect))
		 ('right 0)
		 ('bottom 0)))
	 (guides (if (or (eq? 'left kind) (eq? 'right kind))
		     (get-left-guides wh hwnd)
		     (get-top-guides wh hwnd)))
	 (next (get guides (rect-get kind rect))))
    (if (is-zoomed hwnd)
	(show-window hwnd sw-normal))
    (if (null? next) ()
	(let ((newR (rect-set kind rect next)))
	  (set-window-pos hwnd 0
			  (rect-left newR) (rect-top newR)
			  (rect-width newR) (rect-height newR)
			  (+ swp-nozorder (if resize 0 swp-nosize)))
	  newR))))


;; Alt-F4Iȕ
(define (close-window hwnd)
  (send-message hwnd wm-syscommand #xf060 0))
;  (send-message hwnd wm-close 0 0))

