;; WindowsManager ݒt@C

(load "winmove.scm")

;;;; toggle console
(set-key (+ mod-alt mod-control) #\d
	 (lambda ()
	   (show-console (not (is-visible console-hwnd)))))

;;;; fobOp̃R\[͕\Ȃ
;;;; alt+ctrl+dŊJ
(show-console #f)
	 

(define (toggle-window-state hwnd)
  (show-window hwnd
	       (cond ((is-zoomed hwnd) sw-normal)
		     (else             sw-maximize))))

;; toggle window state
(set-key mod-alt vk-space
	 (lambda () (toggle-window-state (get-foreground-window))))
(set-key mod-alt vk-return
	 (lambda ()
	   (show-window (get-foreground-window) sw-minimize)))

;; move
(set-key (+ mod-control mod-win) #\k
	 (lambda () (winmove 'top #f #f)))
(set-key (+ mod-control mod-win) #\j
	 (lambda () (winmove 'top #t #f)))
(set-key (+ mod-control mod-win) #\h
	 (lambda () (winmove 'left #f #f)))
(set-key (+ mod-control mod-win) #\l
	 (lambda () (winmove 'left #t #f)))

;; resize
(set-key (+ mod-control mod-win mod-shift) #\k
	 (lambda () (winmove 'bottom #f #t)))
(set-key (+ mod-control mod-win mod-shift) #\j
	 (lambda () (winmove 'bottom #t #t)))
(set-key (+ mod-control mod-win mod-shift) #\h
	 (lambda () (winmove 'right #f #t)))
(set-key (+ mod-control mod-win mod-shift) #\l
	 (lambda () (winmove 'right #t #t)))

;; switch window
;(set-key mod-alt               vk-tab (lambda () (switch-window #t)))
;(set-key (+ mod-alt mod-shift) vk-tab (lambda () (switch-window #f)))

(set-key (+ mod-alt) #\h (lambda () (move-focus 'left )))
(set-key (+ mod-alt) #\l (lambda () (move-focus 'right)))
(set-key (+ mod-alt) #\j (lambda () (move-focus 'down )))
(set-key (+ mod-alt) #\k (lambda () (move-focus 'up   )))

(define (toggle-window-icon-state hwnd)
  (cond ((is-iconic hwnd) (restore-window hwnd))
	(else             (show-window hwnd sw-minimize))))

(set-key mod-alt #\m
	 (lambda ()
	   (toggle-window-icon-state (find-window () "Windows Media Player"))))

;; ^XNo[o
;(define (toggle-taskbar)
;  (let ((taskbar (find-window "Shell_TrayWnd" ())))
;    (cond ((is-window-visible taskbar) (show-window taskbar sw-hide))
;	  (else                        (show-window taskbar sw-normal)))))
(define (find-taskbar)
  (find-window "Shell_TrayWnd" ()))

(define (resize-taskbar height)
  (let ((taskbar (find-taskbar))
	(h (cond ((= height 0) 8)
		 (else         (* height 32)))))
    (set-window-pos taskbar 0 0 0 0 h (+ swp-nomove swp-nozorder swp-nosendchanging))
    (send-message taskbar wm-exitsizemove 0 0)))

(define (toggle-taskbar)
  (let ((taskbar (find-taskbar)))
    (if (is-window-visible taskbar)
	(begin
	  ; ^XNo[TCYĂȂ
	  ; ő剻ꂽEBhẼTCYfȂ
	  (resize-taskbar 0)
	  (show-window taskbar sw-hide))
	(begin
	  ; ^XNo[\Ă烊TCYȂ
	  ; ő剻ꂽEBhẼTCYfȂ
	  (show-window taskbar sw-normal)
	  (resize-taskbar 3)))))          ; 3̕ύX鎖ŁC^XNo[̃TCYς܂

(set-key mod-alt #\q toggle-taskbar)


;;; launcher

;; 1sR\[IȂ ipconfigƂɎgƕ֗H
;; Alt+uϊvŌ鑋ŁCR}hłEnterŎsD
(define (cmd-pause-proc hwnd msg wparam lparam)
  (cond
    ((= msg wm-keydown)
     (cond
      ((= wparam vk-return)
       (let ((cmd (get-window-text hwnd)))
	 (launch (string-append "cmd /C \"" cmd "\"&pause"))
	 (post-quit-message 0)))
      ((= wparam vk-escape)
       (post-quit-message 0))))))

(define (cmd-pause-launcher)
  (set-foreground-window
   (create-window-ex cmd-pause-proc
		     (+ ws-ex-toolwindow ws-ex-topmost ws-ex-clientedge ws-ex-dlgmodalframe)
		     "EDIT" ""
		     (+ ws-popupwindow)
		     (/ (- (get-system-metrics sm-cxscreen) 200) 2)
		     (/ (- (get-system-metrics sm-cyscreen) 32)  2)
		     200
		     32)))

(set-key mod-alt vk-convert cmd-pause-launcher)


;; 郉`DOƃAvP[V̑Ήt
;; ҂KKLauncher[UȂ̂ŎgĂȂ

; OƃAvP[V̑Ή
; O͑啶ŏȂ΂ȂȂ
(define apps
  '(("NOTE" "notepad")
    ("CALC" "calc")
    ("GGL"  "D:\\Program Files\\Mozilla Firefox\\firefox.exe http://www.google.co.jp")))

(define (launcher-proc hwnd msg wparam lparam)
  (cond
    ((= msg wm-keydown)
     (cond
      ((= wparam vk-return)
       (let* ((name (get-window-text hwnd))
	      (cmd  (alist-find apps name)))
	 (if cmd
	     (begin
	       (display "ugu")
	       (display (string-append "launch " cmd))
	       (newline)
	       (launch cmd)
	       (post-quit-message 0))
	     (begin
	       (display "else ")
	       (display name)
	       (post-quit-message 0)))))
      ((= wparam vk-escape)
       (post-quit-message 0))))))

(define (launcher)
  (set-foreground-window
   (create-window-ex launcher-proc
		     (+ ws-ex-toolwindow ws-ex-topmost ws-ex-clientedge ws-ex-dlgmodalframe)
		     "EDIT" ""
		     (+ ws-popupwindow es-uppercase)
		     (/ (- (get-system-metrics sm-cxscreen) 200) 2)
		     (/ (- (get-system-metrics sm-cyscreen) 32)  2)
		     200
		     32)))

;(set-key mod-alt #\c launcher)
